process SecondDegree_ABSTRACT =
     ( ? boolean OK;
         real a, b, c;
       ! boolean err;
         real x21, x2;
         boolean stable, C_y, C_OK, C_err, C_x;
     )
   pragmas 
      Grey_Box "SecondDegree"
   end pragmas
   (| (| Tick := true
       | when Tick ^= stable ^= C_y ^= C_x
       | when OK ^= C_err
       | when stable ^= a ^= b ^= c ^= C_OK
       | when C_y ^= x2
       | when C_OK ^= OK
       | when C_err ^= err
       | when C_x ^= x21
       |)
    | (| nlabel :: (err,x21,x2,C_y,C_err,C_x) := SecondDegree_Cluster_1(OK)
       | nlabel ^= when Tick
       |)
    | (| nlabel_994 :: SecondDegree_Cluster_2(OK,b)
       | nlabel_994 ^= when stable
       |)
    | (| nlabel_995 :: SecondDegree_Cluster_3(OK,c)
       | nlabel_995 ^= when stable
       |)
    | (| nlabel_996 :: SecondDegree_Cluster_4(OK,a)
       | nlabel_996 ^= when Tick
       |)
    | (| nlabel_997 :: C_OK := SecondDegree_Cluster_5(a)
       | nlabel_997 ^= when Tick
       |)
    | (| nlabel_1030 :: stable := SecondDegree_Cluster_delays()
       | nlabel_1030 ^= when Tick
       |)
    | (| c --> nlabel
       | b --> nlabel
       | a --> nlabel
       | OK --> nlabel
       | nlabel_994 --> nlabel
       | b --> nlabel_994
       | OK --> nlabel_994
       | nlabel_995 --> nlabel
       | c --> nlabel_995
       | OK --> nlabel_995
       | nlabel_996 --> nlabel_995
       | nlabel_996 --> nlabel_994
       | nlabel_996 --> nlabel
       | a --> nlabel_996
       | OK --> nlabel_996
       | nlabel_997 --> nlabel_996
       | nlabel_997 --> nlabel
       | a --> nlabel_997
       | nlabel_997 --> nlabel_1030
       | nlabel_996 --> nlabel_1030
       | nlabel_995 --> nlabel_1030
       | nlabel_994 --> nlabel_1030
       | nlabel --> nlabel_1030
       |)
    |)
   where 
   boolean Tick;
   label nlabel, nlabel_994, nlabel_995, nlabel_996, nlabel_997, nlabel_1030; 
   action SecondDegree_Cluster_1 =
        ( ? boolean OK;
          ! boolean err;
            real x21;
            real x2;
            boolean C_y;
            boolean C_err;
            boolean C_x;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_2 =
        ( ? boolean OK;
            real b;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_3 =
        ( ? boolean OK;
            real c;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_4 =
        ( ? boolean OK;
            real a;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_5 =
        ( ? real a;
          ! boolean C_OK;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_delays =
        ( ! boolean stable init true;
        )
      pragmas 
         DelayCluster
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   ; 
   end
; 
