process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean error;
     )
   (| (| OK := a/=0.0
       | (| SecondDegree_ABS(a,b,c) |)/ C_y
                                      / stable
                                      / C_err
                                      / C_bb
                                      / C_x
       | FirstDegree(not OK,b,c)
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | error := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK |)
   where 
   constant real cst_epsilon = 0.0001;
   boolean err2, err, C_x, C_bb, C_err, stable, C_OK, OK, C_y, C_error, C_cc1;
   process FirstDegree =
        ( ? boolean Compute;
            real b;
            real c;
          ! real x;
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error;
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 
   process SecondDegree_ABS =
        ( ? real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable init true, C_y, C_bb, C_err, C_x;
        )
        spec (| (| a --> err
                 | b --> err
                 | c --> err
                 | a --> x21
                 | b --> x21
                 | c --> x21
                 | a --> x2
                 | b --> x2
                 | c --> x2
                 |)
              | (| stable ^= C_y ^= C_x
                 | when stable ^= a ^= b ^= c ^= C_bb
                 | when C_y ^= x2
                 | when C_bb ^= C_err
                 | when C_err ^= err
                 | when C_x ^= x21
                 |)
              |)
      pragmas 
         Black_Box "SecondDegree"
      end pragmas
      external "C"
   ; 
   real x21, x;
   end
; 
